
package de.ivu.elect.presentation.ergebniskonflikt.menu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisSessionSelect;
import de.ivu.elect.business.ergebniskonflikt.entity.AbstractErgebnisKonfliktLosoptionenCustomData;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.ergebnis.menu.ErgebnisMenuDisabled;
import de.ivu.elect.presentation.ergebniskonflikt.ErgebnisKonfliktSearchView;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public class ErgebnisKonfliktSearchMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private ErgebnisSessionSelect sessionSelect;

  @Inject
  private transient ErgebnisMenuDisabled ergebnisMenuDisabled;


  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.ERGEBNIS_KONFLIKT_SEARCH);
  }

  @Override
  public String getLabelKey() {
    return "ergebnis.konflikt.search.menu.item.label";
  }

  @Override
  public String getTargetViewId() {
    return ErgebnisKonfliktSearchView.VIEW_ID;
  }

  @Override
  public boolean isDisabledInternal() {
    return ergebnisMenuDisabled.isDisabled(this) || sessionSelect.getEntity() == null|| sessionSelect.getEntity().isStatusUnbekannt();
  }

  @Override
  public String getIcon() {
    return getIcons().getIconHelp();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY;
  }

  @Override
  protected List<String> getAdditionalTopicViewIds() {
    return Collections.singletonList(AbstractErgebnisKonfliktLosoptionenCustomData.VIEW_ID);
  }
}
